open Printf
type action = Ast | Sast | Cgen

let _ = 
  let action = 
    if Array.length Sys.argv > 1 then
      List.assoc Sys.argv.(1) [ ("-a", Ast); ("-s", Sast); ("-c", Cgen); ]
    else 
      Cgen 
  in
  let filename = 
    if action == Cgen && Array.length Sys.argv > 2 then Sys.argv.(2)
    else "kgl_generated.cc" 
  in  

  let lexbuf = Lexing.from_channel stdin in
  let prog = Parser.test Scanner.token lexbuf in
  match action with
      Ast -> print_string (Ast.string_of_program prog)
    | Sast -> print_string "SAST"
    | Cgen -> let sast = Semantic.check_program prog in
              let cast = Cast.to_c_program sast in
              let c_code = Cast.string_c_program cast in
              let file = open_out (filename) in
              fprintf file "%s" c_code
